// LOGGER.H
// Logging and function entry/return tracking functions
#ifndef _LOGGER_H_
#define _LOGGER_H_

#ifndef NO_FENTRY
#include "stdtypes.h"
#define FENTRY(S,D,T)  function_entry ( __FILE__, __LINE__, __FUNCTION__, (S), (D), (T) );
#define FEXTRA(S,D,T)  function_extra ( __FILE__, __LINE__, __FUNCTION__, (S), (D), (T) );
#define ERROR(S,E)     errortrap ( (S), (E) );
#define FEXIT   function_exit();
#define LOG(S)  llog ( __FILE__, __FUNCTION__, __LINE__, (S) );

void function_entry ( char *filename, int    lineno, char *funcname, 
                      char *s,        ptrint d,      char *type );
void function_extra ( char *filename, int    lineno, char *funcname, 
                      char *s,        ptrint d,      char *type );
void function_exit();
void llog ( char *filename, char *funcname, int linenum, char *s );
void errortrap ( char *s, int exitprocess );

#else
#define FENTRY(S,D,T)  1;
#define FEXTRA(S,D,T)  1;
#define ERROR(S,E)     1;
#define FEXIT          1;
#define LOG(S)         1;
#define errortrap(A,B) 1;
#endif

#endif

