// Regular Expression library wrapper for PCRE -- easier to use, with 
// compiled expression caching and function profiling.
#ifndef _RE_H_
#define _RE_H_
#include "extant.h"

#ifndef   _RE_C_
// regex matches are stuck in 'x', unless 'x' is NULL
// re returns 0 on no match, > 0 on match, < 0 on error
int re     ( char *pattern, char *s, xpt *x );
int re_ctl ( int parameter, int value );
#endif // _RE_C_

#define RECTL_GET_CACHE_REPLACEMENT_POLICY_DEFAULT (1)
#define RECTL_GET_CACHE_REPLACEMENT_POLICY         (2)
#define RECTL_SET_CACHE_REPLACEMENT_POLICY         (3)
#define RECTL_GET_POSTCOMPILE_DEFAULT              (4)
#define RECTL_GET_POSTCOMPILE                      (5)
#define RECTL_SET_POSTCOMPILE                      (6)
#define RECTL_GET_CACHE_SLOTS                      (7)
#define RECTL_GET_N_VECTORS                        (8)
#define RECTL_SET_DEBUG                            (9)
#define RECTL_GET_DEBUG                           (10)

#ifndef  REGEX_CACHE_SLOTS
#define  REGEX_CACHE_SLOTS  (1023)
#endif

#ifndef  REGEX_DEFAULT_REPLACEMENT_POLICY
#define  REGEX_DEFAULT_REPLACEMENT_POLICY  (0)
#endif

#ifndef  REGEX_DEFAULT_POSTCOMPILE
#define  REGEX_DEFAULT_POSTCOMPILE (1)
#endif

#ifndef  REGEX_N_VECTORS
#define  REGEX_N_VECTORS (128)
#endif

#endif // _RE_H_
